OKS API v1.0
The OKS API enables you to interact with OUTSCALE Kubernetes as a Service (OKS), a managed Kubernetes service on the OUTSCALE Cloud.
In OKS, each cluster is linked to a project. In a project, you can have several clusters. Templates are also available for different resources.
For more information about the service, see About OKS.
An OpenAPI description of this API is also available for download:
Endpoints
| Base URL |
|---|
| https://api.eu-west-2.oks.outscale.com/api/v2 |
| https://api.cloudgouv-eu-west-1.oks.outscale.com/api/v2 |
Authentication Schemes
There are 3 possible ways to authenticate your requests with the OKS API:
Basic Authentication
| Element | Description |
|---|---|
Authorization header |
A header in the form Basic XXXX, where XXXX is the Base64 encoding of the root user's login and password joined by a colon (:). Note that with Curl, you can use the --user LOGIN:PASSWORD option as a shortcut for this and Curl will format the header for you. |
X-OTP-Code header |
(optional) If multi-factor authentication (MFA) is set up on your account, a header with your OTP token. |
Access Key/Secret Key
| Element | Description |
|---|---|
AccessKey header |
A header with an access key of the root user. You cannot use EIM users' access keys with OKS. |
SecretKey header |
A header with the corresponding secret key of the access key. |
X-OTP-Code header |
(optional) If multi-factor authentication (MFA) is set up on your account, a header with your OTP token. |
Access Token/Refresh Token
| Element | Description |
|---|---|
AccessToken header |
In the case of JSON Web Token (JWT) authentication, a header with an access token. |
RefreshToken header |
In the case of JWT authentication, a header with the corresponding refresh token. |
Clusters
CreateCluster
POST /clusters
Creates a cluster with the provided configuration.
Request Parameters
# Example with access key/secret key authentication
# (See the "Authentication Schemes" section for other authentications)
curl -X POST 'https://api.'$OSC_REGION'.oks.outscale.com/api/v2/clusters' \
--header 'AccessKey: '$OSC_ACCESS_KEY \
--header 'SecretKey: '$OSC_SECRET_KEY \
--header 'Content-Type: application/json' \
--data '{
"name": "awesome-cluster",
"project_id": "string",
"description": "",
"cp_multi_az": true,
"cp_subregions": [],
"version": "string",
"admin_lbu": false,
"admission_flags": {},
"cidr_pods": "10.91.0.0/16",
"cidr_service": "10.92.0.0/16",
"cluster_dns": "10.92.0.10",
"tags": {
"key": "value"
},
"auto_maintenances": {
"minor_upgrade_maintenance": {
"enabled": true,
"duration_hours": 0,
"start_hour": 12,
"week_day": "Mon",
"tz": "UTC"
},
"patch_upgrade_maintenance": {
"enabled": true,
"duration_hours": 0,
"start_hour": 12,
"week_day": "Mon",
"tz": "UTC"
}
},
"maintenance_window": {
"duration_hours": 23,
"start_hour": 23,
"week_day": "Mon",
"tz": "UTC"
},
"control_planes": "cp.3.masters.small",
"admin_whitelist": ["string"],
"quirks": ["string"],
"disable_api_termination": false,
"auth": {
"oidc": {
"issuer-url": "string",
"client-id": "string",
"username-claim": "string",
"username-prefix": "string",
"groups-claim": ["string"],
"groups-prefix": "string",
"required-claim": {"claim": "value"}
}
}
}'
# Example with access key/secret key authentication
# (See the "Authentication Schemes" section for other authentications)
POST /api/v2/clusters HTTP/1.1
Host: api.eu-west-2.oks.outscale.com
Content-Type: application/json
AccessKey: XXXX
SecretKey: YYYY
{
"name": "awesome-cluster",
"project_id": "string",
"description": "",
"cp_multi_az": true,
"cp_subregions": [],
"version": "string",
"admin_lbu": false,
"admission_flags": {},
"cidr_pods": "10.91.0.0/16",
"cidr_service": "10.92.0.0/16",
"cluster_dns": "10.92.0.10",
"tags": {
"key": "value"
},
"auto_maintenances": {
"minor_upgrade_maintenance": {
"enabled": true,
"duration_hours": 0,
"start_hour": 12,
"week_day": "Mon",
"tz": "UTC"
},
"patch_upgrade_maintenance": {
"enabled": true,
"duration_hours": 0,
"start_hour": 12,
"week_day": "Mon",
"tz": "UTC"
}
},
"maintenance_window": {
"duration_hours": 23,
"start_hour": 23,
"week_day": "Mon",
"tz": "UTC"
},
"control_planes": "cp.3.masters.small",
"admin_whitelist": ["string"],
"quirks": ["string"],
"disable_api_termination": false,
"auth": {
"oidc": {
"issuer-url": "string",
"client-id": "string",
"username-claim": "string",
"username-prefix": "string",
"groups-claim": ["string"],
"groups-prefix": "string",
"required-claim": {"claim": "value"}
}
}
}
See the outscale_oks_cluster resource in the Terraform OUTSCALE provider.
Body (ClusterInput object):
| Body Parameter | Type | Description |
|---|---|---|
| name (required) | string | A unique name for the cluster within the project. Length: 1 to 40 characters. Pattern: ^[a-z][a-z0-9-]*[a-z0-9]$.Example: awesome-cluster. |
| project_id (required) | string | The ID of the project in which you want to create a cluster. |
| description | string, or null |
A description of the cluster. Default: . |
| cp_multi_az | boolean | If true, multi-Subregion deployment is enabled for the control plane. If false, it is disabled. |
| cp_subregions | [string] | The list of Subregions where control plane components are deployed. Default: []. |
| version (required) | string | The Kubernetes version to be deployed for the cluster. For more information, see GetKubernetesVersions. |
| admin_lbu | boolean | If true, load balancer administration is enabled for cluster management. If false, it is disabled. Default: false. |
| admission_flags | AdmissionFlagsInput object | The configuration for Kubernetes admission controllers. Default: {}. |
| disable_admission_plugins | [string] | The list of Kubernetes admission plugins to disable. |
| enable_admission_plugins | [string] | The list of Kubernetes admission plugins to enable. |
| cidr_pods (required) | string | The CIDR block for Kubernetes pods' network. Example: 10.91.0.0/16. |
| cidr_service (required) | string | The CIDR block for the Kubernetes services' network. Example: 10.92.0.0/16. |
| cluster_dns | string | The IP for the cluster's DNS service. Example: 10.92.0.10. |
| tags | object, or null |
The key/value combinations of the tags associated with the cluster's metadata, in the following format: "tags":{"TAGKEY1":"TAGVALUE1","TAGKEY2":"TAGVALUE2"}.Example: {"key": "value"}. |
| additional properties | string | |
| auto_maintenances Deprecated | AutoMaintenances object | The configuration for automated maintenance windows. |
| minor_upgrade_maintenance (required) | MaintenanceWindow object | The maintenance window configuration for minor Kubernetes upgrades. |
| enabled | boolean | If true, a maintenance window is enabled. Default: true. |
| duration_hours | integer | The duration of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. Default: 0. |
| start_hour | integer | The starting time of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. Default: 12. |
| week_day | string | The weekday on which the maintenance window begins. Possible values: Mon | Tue | Wed | Thu | Fri | Sat | Sun | string. Default: Tue. |
| tz | string | The timezone for the maintenance window. Default: UTC. |
| patch_upgrade_maintenance (required) | MaintenanceWindow object | The maintenance window configuration for patch Kubernetes upgrades. |
| enabled | boolean | If true, a maintenance window is enabled. Default: true. |
| duration_hours | integer | The duration of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. Default: 0. |
| start_hour | integer | The starting time of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. Default: 12. |
| week_day | string | The weekday on which the maintenance window begins. Possible values: Mon | Tue | Wed | Thu | Fri | Sat | Sun | string. Default: Tue. |
| tz | string | The timezone for the maintenance window. Default: UTC. |
| maintenance_window | Maintenance object | The configuration for automated maintenance windows. |
| duration_hours (required) | integer | The duration of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. |
| start_hour (required) | integer | The starting time of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. |
| week_day (required) | string | The weekday on which the maintenance window begins. Possible values: Mon | Tue | Wed | Thu | Fri | Sat | Sun | string. |
| tz | string | The timezone for the maintenance window. Default: UTC. |
| control_planes | string | The size of control plane deployment for the cluster. For more information, see About OKS > Control Planes. Default: cp.3.masters.small. |
| admin_whitelist (required) | [string] | The list of CIDR blocks or IPs allowed to access the cluster via the Kubernetes API. |
| quirks | [string], or null |
The list of special configurations or behaviors for the cluster. |
| disable_api_termination | boolean | If true, cluster deletion through the API is disabled. If false, it is enabled. Default: false. |
| auth | AuthStrategy object, or null |
The authentication strategy used to access the cluster. |
| oidc | OpenIdConnectConfig object, or null |
The configuration for authenticating to the cluster using OpenID Connect (OIDC). |
| issuer-url (required) | string | The server URL of the OIDC provider, using the HTTPS protocol (https://). |
| client-id (required) | string | The client ID provided by the OIDC provider. This will be used by the cluster to connect to the server. |
| username-claim | string, or null |
A JSON Web Token (JWT) claim provided by the OIDC provider. This will be used to retrieve the username on the Kubernetes side. |
| username-prefix | string, or null |
A prefix added to the Kubernetes username, to prevent clashing with existing names (for example, oidc:). |
| groups-claim | [string], or null |
A JSON Web Token (JWT) claim provided by the OIDC provider. This will be used to retrieve the user's group on the Kubernetes side. |
| groups-prefix | string, or null |
A prefix added to the Kubernetes group, to prevent clashing with existing names (for example, oidc:). |
| required-claim | object, or null |
The key/value combination of OIDC claims that must be included in the ID token for the user to authenticate. If not specified, no claim-based restrictions are enforced. Example: {"claim": "value"}. |
| additional properties | string, or boolean, or integer, or number |
Response Elements
{
"ResponseContext": {
"RequestId": "string"
},
"Cluster": {
"project_id": "string",
"id": "string",
"name": "string",
"description": "",
"cp_multi_az": true,
"cp_subregions": [
"string"
],
"version": "string",
"expected_version": "string",
"cni": "string",
"admin_lbu": true,
"admission_flags": {
"disable_admission_plugins": [],
"enable_admission_plugins": [],
"applied_admission_plugins": [
"CertificateApproval",
"CertificateSigning",
"CertificateSubjectRestriction",
"ClusterTrustBundleAttest",
"DefaultIngressClass",
"DefaultStorageClass",
"DefaultTolerationSeconds",
"LimitRanger",
"MutatingAdmissionWebhook",
"NamespaceLifecycle",
"PersistentVolumeClaimResize",
"PodSecurity",
"Priority",
"ResourceQuota",
"RuntimeClass",
"ServiceAccount",
"StorageObjectInUseProtection",
"TaintNodesByCondition",
"ValidatingAdmissionPolicy",
"ValidatingAdmissionWebhook"
]
},
"cidr_pods": "string",
"cidr_service": "string",
"cluster_dns": "string",
"tags": {
"key": "value"
},
"auto_maintenances": {
"minor_upgrade_maintenance": {
"enabled": true,
"duration_hours": 0,
"start_hour": 12,
"week_day": "Mon",
"tz": "UTC"
},
"patch_upgrade_maintenance": {
"enabled": true,
"duration_hours": 0,
"start_hour": 12,
"week_day": "Mon",
"tz": "UTC"
}
},
"maintenance_window": {
"duration_hours": 23,
"start_hour": 23,
"week_day": "Mon",
"tz": "UTC"
},
"control_planes": "string",
"expected_control_planes": "string",
"admin_whitelist": [
"string"
],
"statuses": {
"created_at": "2019-08-24T14:15:22Z",
"deleted_at": "2019-08-24T14:15:22Z",
"updated_at": "2019-08-24T14:15:22Z",
"status": "string",
"available_upgrade": ""
},
"disable_api_termination": false,
"auth": {
"oidc": {
"issuer-url": "string",
"client-id": "string",
"username-claim": "string",
"username-prefix": "string",
"groups-claim": [
"string"
],
"groups-prefix": "string",
"required-claim": {
"claim": "value"
}
}
}
}
}
200 response (ClusterResponse object):
| Response Element | Type | Description |
|---|---|---|
| ResponseContext | clusters__cluster_schema__ResponseContext object | Information about the context of the response. |
| RequestId | string | The ID of the API request. |
| Cluster | Cluster object | Information about the cluster. |
| project_id | string | The ID of the project this cluster belongs to. |
| id | string | The Universally Unique Identifier (UUID) of the cluster. |
| name | string | A unique name for the cluster within the project. |
| description | string | An optional description of the cluster. Default: . |
| cp_multi_az | boolean | If true, multi-Subregion deployment is enabled for the control plane. If false, it is disabled. |
| cp_subregions | [string] | The Subregions on which the control plane components are deployed. |
| version | string | The Kubernetes version deployed for the cluster. For more information, see GetKubernetesVersions. |
| expected_version | string, or null |
The version of Kubernetes that is expected to be deployed during maintenance. |
| cni | string | The Container Network Interface (CNI) used in the cluster. |
| admin_lbu | boolean | If true, load balancer administration is enabled for cluster management. If false, it is disabled. |
| admission_flags | AdmissionFlags object | The configuration for Kubernetes admission controllers. |
| disable_admission_plugins | [string] | The list of Kubernetes admission plugins that are disabled. Default: []. |
| enable_admission_plugins | [string] | The list of Kubernetes admission plugins that are enabled. Default: []. |
| applied_admission_plugins | [string] | The list of admission plugins that are currently applied to the cluster. Default: ["CertificateApproval", "CertificateSigning", "CertificateSubjectRestriction", "ClusterTrustBundleAttest", "DefaultIngressClass", "DefaultStorageClass", "DefaultTolerationSeconds", "LimitRanger", "MutatingAdmissionWebhook", "NamespaceLifecycle", "PersistentVolumeClaimResize", "PodSecurity", "Priority", "ResourceQuota", "RuntimeClass", "ServiceAccount", "StorageObjectInUseProtection", "TaintNodesByCondition", "ValidatingAdmissionPolicy", "ValidatingAdmissionWebhook"]. |
| cidr_pods | string | The CIDR block of the Kubernetes pods' network. |
| cidr_service | string | The CIDR block of the Kubernetes services' network. |
| cluster_dns | string | The IP of the cluster's DNS service. |
| tags | object | The key/value combinations of the tags associated with the cluster, in the following format: "tags":{"TAGKEY1":"TAGVALUE1","TAGKEY2":"TAGVALUE2"}.Example: {"key": "value"}. |
| additional properties | string | |
| auto_maintenances Deprecated | AutoMaintenances object, or null |
The configuration for automated maintenance windows. |
| minor_upgrade_maintenance | MaintenanceWindow object | The maintenance window configuration for minor Kubernetes upgrades. |
| enabled | boolean | If true, a maintenance window is enabled. Default: true. |
| duration_hours | integer | The duration of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. Default: 0. |
| start_hour | integer | The starting time of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. Default: 12. |
| week_day | string | The weekday on which the maintenance window begins. Possible values: Mon | Tue | Wed | Thu | Fri | Sat | Sun | string. Default: Tue. |
| tz | string | The timezone for the maintenance window. Default: UTC. |
| patch_upgrade_maintenance | MaintenanceWindow object | The maintenance window configuration for patch Kubernetes upgrades. |
| enabled | boolean | If true, a maintenance window is enabled. Default: true. |
| duration_hours | integer | The duration of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. Default: 0. |
| start_hour | integer | The starting time of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. Default: 12. |
| week_day | string | The weekday on which the maintenance window begins. Possible values: Mon | Tue | Wed | Thu | Fri | Sat | Sun | string. Default: Tue. |
| tz | string | The timezone for the maintenance window. Default: UTC. |
| maintenance_window | Maintenance object, or null |
The configuration for automated maintenance windows. |
| duration_hours | integer | The duration of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. |
| start_hour | integer | The starting time of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. |
| week_day | string | The weekday on which the maintenance window begins. Possible values: Mon | Tue | Wed | Thu | Fri | Sat | Sun | string. |
| tz | string | The timezone for the maintenance window. Default: UTC. |
| control_planes | string | The control plane sizing of the cluster. |
| expected_control_planes | string, or null |
The type of control plane size that is expected. |
| admin_whitelist | [string] | The list of CIDR blocks or IPs allowed to access the cluster via the Kubernetes API. |
| statuses | Statuses object | The status information of the cluster. |
| created_at | string (date-time) | The timestamp when the cluster was created. |
| deleted_at | string (date-time), or null |
The timestamp when the cluster was deleted (if applicable). |
| updated_at | string (date-time), or null |
The timestamp when the cluster was last updated. |
| status | string, or null |
The status of the cluster. |
| available_upgrade | string | Any available version of Kubernetes for upgrade (if applicable). For more information, see GetKubernetesVersions. Default: . |
| disable_api_termination | boolean | If true, cluster deletion through the API is disabled. If false, it is enabled. Default: false. |
| auth | AuthStrategy object, or null |
The authentication strategy used to access the cluster. |
| oidc | OpenIdConnectConfig object, or null |
The configuration for authenticating to the cluster using OpenID Connect (OIDC). |
| issuer-url | string | The server URL of the OIDC provider, using the HTTPS protocol (https://). |
| client-id | string | The client ID provided by the OIDC provider. This will be used by the cluster to connect to the server. |
| username-claim | string, or null |
A JSON Web Token (JWT) claim provided by the OIDC provider. This will be used to retrieve the username on the Kubernetes side. |
| username-prefix | string, or null |
A prefix added to the Kubernetes username, to prevent clashing with existing names (for example, oidc:). |
| groups-claim | [string], or null |
A JSON Web Token (JWT) claim provided by the OIDC provider. This will be used to retrieve the user's group on the Kubernetes side. |
| groups-prefix | string, or null |
A prefix added to the Kubernetes group, to prevent clashing with existing names (for example, oidc:). |
| required-claim | object, or null |
The key/value combination of OIDC claims that must be included in the ID token for the user to authenticate. If not specified, no claim-based restrictions are enforced. Example: {"claim": "value"}. |
| additional properties | string, or boolean, or integer, or number |
Other responses:
- 400 response (ErrorResponse object): The HTTP 400 response (Bad Request).
- 403 response (ErrorResponse object): The HTTP 403 response (Forbidden).
- 404 response (ErrorResponse object): The HTTP 404 response (Not Found).
- 409 response (ErrorResponse object): The HTTP 409 response (Conflict).
- 422 response (ErrorResponse object): The HTTP 422 response (Unprocessable Content).
- 423 response (ErrorResponse object): The HTTP 423 response (Locked Resource).
- 500 response (ErrorResponse object): The HTTP 500 response (Internal Server Error).
- 501 response (ErrorResponse object): The HTTP 501 response (Not Implemented).
- 503 response (ErrorResponse object): The HTTP 503 response (Service Unavailable).
ListClustersByProjectID
GET /clusters
Lists one or more clusters associated with a project. The response can be filtered using the parameters.
Request Parameters
# Example with access key/secret key authentication
# (See the "Authentication Schemes" section for other authentications)
curl -X GET 'https://api.'$OSC_REGION'.oks.outscale.com/api/v2/clusters?project_id=string&name=string&status=string&version=string&deleted=true&cursor=string&page=0&limit=1' \
--header 'AccessKey: '$OSC_ACCESS_KEY \
--header 'SecretKey: '$OSC_SECRET_KEY
# Example with access key/secret key authentication
# (See the "Authentication Schemes" section for other authentications)
GET /api/v2/clusters?project_id=string&name=string&status=string&version=string&deleted=true&cursor=string&page=0&limit=1 HTTP/1.1
Host: api.eu-west-2.oks.outscale.com
AccessKey: XXXX
SecretKey: YYYY
There is no equivalent for this method in the Terraform OUTSCALE provider.
Query:
| Query Parameter | Type | Description |
|---|---|---|
| project_id | string, or null |
The ID of the project. |
| name | string, or null |
The name of the clusters. |
| status | string, or null |
The status of the clusters. |
| version | string, or null |
The version of the clusters. |
| deleted | boolean, or null |
If true, returns deleted clusters. |
| cursor | string, or null |
The token to indicate where the next set of results should start. |
| page | integer, or null |
The page number of results to retrieve. |
| limit | integer, or null |
The maximum number of results to return in the response. |
Response Elements
{
"ResponseContext": {
"RequestId": "string"
},
"Pagination": {
"cursor": {
"next_cursor": "string"
},
"offset": {
"page": 0,
"limit": 0,
"total": 0
}
},
"Clusters": [
{
"project_id": "string",
"id": "string",
"name": "string",
"description": "",
"cp_multi_az": true,
"cp_subregions": [
"string"
],
"version": "string",
"expected_version": "string",
"cni": "string",
"admin_lbu": true,
"admission_flags": {
"disable_admission_plugins": [],
"enable_admission_plugins": [],
"applied_admission_plugins": [
"CertificateApproval",
"CertificateSigning",
"CertificateSubjectRestriction",
"ClusterTrustBundleAttest",
"DefaultIngressClass",
"DefaultStorageClass",
"DefaultTolerationSeconds",
"LimitRanger",
"MutatingAdmissionWebhook",
"NamespaceLifecycle",
"PersistentVolumeClaimResize",
"PodSecurity",
"Priority",
"ResourceQuota",
"RuntimeClass",
"ServiceAccount",
"StorageObjectInUseProtection",
"TaintNodesByCondition",
"ValidatingAdmissionPolicy",
"ValidatingAdmissionWebhook"
]
},
"cidr_pods": "string",
"cidr_service": "string",
"cluster_dns": "string",
"tags": {
"key": "value"
},
"auto_maintenances": {
"minor_upgrade_maintenance": {
"enabled": true,
"duration_hours": 0,
"start_hour": 12,
"week_day": "Mon",
"tz": "UTC"
},
"patch_upgrade_maintenance": {
"enabled": true,
"duration_hours": 0,
"start_hour": 12,
"week_day": "Mon",
"tz": "UTC"
}
},
"maintenance_window": {
"duration_hours": 23,
"start_hour": 23,
"week_day": "Mon",
"tz": "UTC"
},
"control_planes": "string",
"expected_control_planes": "string",
"admin_whitelist": [
"string"
],
"statuses": {
"created_at": "2019-08-24T14:15:22Z",
"deleted_at": "2019-08-24T14:15:22Z",
"updated_at": "2019-08-24T14:15:22Z",
"status": "string",
"available_upgrade": ""
},
"disable_api_termination": false,
"auth": {
"oidc": {
"issuer-url": "string",
"client-id": "string",
"username-claim": "string",
"username-prefix": "string",
"groups-claim": [
"string"
],
"groups-prefix": "string",
"required-claim": {
"claim": "value"
}
}
}
}
]
}
200 response (ClusterResponseList object):
| Response Element | Type | Description |
|---|---|---|
| ResponseContext | clusters__cluster_schema__ResponseContext object | Information about the context of the response. |
| RequestId | string | The ID of the API request. |
| Pagination | Pagination object | Information used to split large lists of results into multiple responses (either cursor or offset-based). |
| cursor | Cursor object, or null |
Information used for cursor-based pagination. |
| next_cursor | string, or null |
The pagination token indicating where the next set of results should start. |
| offset | Offset object, or null |
Information used for offset-based pagination. |
| page | integer, or null |
The page number of the current results. |
| limit | integer, or null |
The maximum number of results returned per page. |
| total | integer, or null |
The total number of available results. |
| Clusters | [Cluster object] | Information about the clusters. |
| project_id | string | The ID of the project this cluster belongs to. |
| id | string | The Universally Unique Identifier (UUID) of the cluster. |
| name | string | A unique name for the cluster within the project. |
| description | string | An optional description of the cluster. Default: . |
| cp_multi_az | boolean | If true, multi-Subregion deployment is enabled for the control plane. If false, it is disabled. |
| cp_subregions | [string] | The Subregions on which the control plane components are deployed. |
| version | string | The Kubernetes version deployed for the cluster. For more information, see GetKubernetesVersions. |
| expected_version | string, or null |
The version of Kubernetes that is expected to be deployed during maintenance. |
| cni | string | The Container Network Interface (CNI) used in the cluster. |
| admin_lbu | boolean | If true, load balancer administration is enabled for cluster management. If false, it is disabled. |
| admission_flags | AdmissionFlags object | The configuration for Kubernetes admission controllers. |
| disable_admission_plugins | [string] | The list of Kubernetes admission plugins that are disabled. Default: []. |
| enable_admission_plugins | [string] | The list of Kubernetes admission plugins that are enabled. Default: []. |
| applied_admission_plugins | [string] | The list of admission plugins that are currently applied to the cluster. Default: ["CertificateApproval", "CertificateSigning", "CertificateSubjectRestriction", "ClusterTrustBundleAttest", "DefaultIngressClass", "DefaultStorageClass", "DefaultTolerationSeconds", "LimitRanger", "MutatingAdmissionWebhook", "NamespaceLifecycle", "PersistentVolumeClaimResize", "PodSecurity", "Priority", "ResourceQuota", "RuntimeClass", "ServiceAccount", "StorageObjectInUseProtection", "TaintNodesByCondition", "ValidatingAdmissionPolicy", "ValidatingAdmissionWebhook"]. |
| cidr_pods | string | The CIDR block of the Kubernetes pods' network. |
| cidr_service | string | The CIDR block of the Kubernetes services' network. |
| cluster_dns | string | The IP of the cluster's DNS service. |
| tags | object | The key/value combinations of the tags associated with the cluster, in the following format: "tags":{"TAGKEY1":"TAGVALUE1","TAGKEY2":"TAGVALUE2"}.Example: {"key": "value"}. |
| additional properties | string | |
| auto_maintenances Deprecated | AutoMaintenances object, or null |
The configuration for automated maintenance windows. |
| minor_upgrade_maintenance | MaintenanceWindow object | The maintenance window configuration for minor Kubernetes upgrades. |
| enabled | boolean | If true, a maintenance window is enabled. Default: true. |
| duration_hours | integer | The duration of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. Default: 0. |
| start_hour | integer | The starting time of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. Default: 12. |
| week_day | string | The weekday on which the maintenance window begins. Possible values: Mon | Tue | Wed | Thu | Fri | Sat | Sun | string. Default: Tue. |
| tz | string | The timezone for the maintenance window. Default: UTC. |
| patch_upgrade_maintenance | MaintenanceWindow object | The maintenance window configuration for patch Kubernetes upgrades. |
| enabled | boolean | If true, a maintenance window is enabled. Default: true. |
| duration_hours | integer | The duration of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. Default: 0. |
| start_hour | integer | The starting time of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. Default: 12. |
| week_day | string | The weekday on which the maintenance window begins. Possible values: Mon | Tue | Wed | Thu | Fri | Sat | Sun | string. Default: Tue. |
| tz | string | The timezone for the maintenance window. Default: UTC. |
| maintenance_window | Maintenance object, or null |
The configuration for automated maintenance windows. |
| duration_hours | integer | The duration of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. |
| start_hour | integer | The starting time of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. |
| week_day | string | The weekday on which the maintenance window begins. Possible values: Mon | Tue | Wed | Thu | Fri | Sat | Sun | string. |
| tz | string | The timezone for the maintenance window. Default: UTC. |
| control_planes | string | The control plane sizing of the cluster. |
| expected_control_planes | string, or null |
The type of control plane size that is expected. |
| admin_whitelist | [string] | The list of CIDR blocks or IPs allowed to access the cluster via the Kubernetes API. |
| statuses | Statuses object | The status information of the cluster. |
| created_at | string (date-time) | The timestamp when the cluster was created. |
| deleted_at | string (date-time), or null |
The timestamp when the cluster was deleted (if applicable). |
| updated_at | string (date-time), or null |
The timestamp when the cluster was last updated. |
| status | string, or null |
The status of the cluster. |
| available_upgrade | string | Any available version of Kubernetes for upgrade (if applicable). For more information, see GetKubernetesVersions. Default: . |
| disable_api_termination | boolean | If true, cluster deletion through the API is disabled. If false, it is enabled. Default: false. |
| auth | AuthStrategy object, or null |
The authentication strategy used to access the cluster. |
| oidc | OpenIdConnectConfig object, or null |
The configuration for authenticating to the cluster using OpenID Connect (OIDC). |
| issuer-url | string | The server URL of the OIDC provider, using the HTTPS protocol (https://). |
| client-id | string | The client ID provided by the OIDC provider. This will be used by the cluster to connect to the server. |
| username-claim | string, or null |
A JSON Web Token (JWT) claim provided by the OIDC provider. This will be used to retrieve the username on the Kubernetes side. |
| username-prefix | string, or null |
A prefix added to the Kubernetes username, to prevent clashing with existing names (for example, oidc:). |
| groups-claim | [string], or null |
A JSON Web Token (JWT) claim provided by the OIDC provider. This will be used to retrieve the user's group on the Kubernetes side. |
| groups-prefix | string, or null |
A prefix added to the Kubernetes group, to prevent clashing with existing names (for example, oidc:). |
| required-claim | object, or null |
The key/value combination of OIDC claims that must be included in the ID token for the user to authenticate. If not specified, no claim-based restrictions are enforced. Example: {"claim": "value"}. |
| additional properties | string, or boolean, or integer, or number |
Other responses:
- 400 response (ErrorResponse object): The HTTP 400 response (Bad Request).
- 404 response (ErrorResponse object): The HTTP 404 response (Not Found).
- 422 response (ErrorResponse object): The HTTP 422 response (Unprocessable Content).
- 500 response (ErrorResponse object): The HTTP 500 response (Internal Server Error).
ListAllClusters
GET /clusters/all
Lists one or more of your clusters. The response can be filtered using the parameters.
Request Parameters
# Example with access key/secret key authentication
# (See the "Authentication Schemes" section for other authentications)
curl -X GET 'https://api.'$OSC_REGION'.oks.outscale.com/api/v2/clusters/all?name=string&status=string&version=string&deleted=true&cursor=string&page=0&limit=1' \
--header 'AccessKey: '$OSC_ACCESS_KEY \
--header 'SecretKey: '$OSC_SECRET_KEY
# Example with access key/secret key authentication
# (See the "Authentication Schemes" section for other authentications)
GET /api/v2/clusters/all?name=string&status=string&version=string&deleted=true&cursor=string&page=0&limit=1 HTTP/1.1
Host: api.eu-west-2.oks.outscale.com
AccessKey: XXXX
SecretKey: YYYY
There is no equivalent for this method in the Terraform OUTSCALE provider.
Query:
| Query Parameter | Type | Description |
|---|---|---|
| name | string, or null |
The name of the clusters. |
| status | string, or null |
The status of the clusters. |
| version | string, or null |
The version of the clusters. |
| deleted | boolean, or null |
If true, returns deleted clusters. |
| cursor | string, or null |
The token to indicate where the next set of results should start in cursor-based pagination. |
| page | integer, or null |
The page number of results to retrieve. |
| limit | integer, or null |
The maximum number of results to return in the response. |
Response Elements
{
"ResponseContext": {
"RequestId": "string"
},
"Pagination": {
"cursor": {
"next_cursor": "string"
},
"offset": {
"page": 0,
"limit": 0,
"total": 0
}
},
"Clusters": [
{
"project_id": "string",
"id": "string",
"name": "string",
"description": "",
"cp_multi_az": true,
"cp_subregions": [
"string"
],
"version": "string",
"expected_version": "string",
"cni": "string",
"admin_lbu": true,
"admission_flags": {
"disable_admission_plugins": [],
"enable_admission_plugins": [],
"applied_admission_plugins": [
"CertificateApproval",
"CertificateSigning",
"CertificateSubjectRestriction",
"ClusterTrustBundleAttest",
"DefaultIngressClass",
"DefaultStorageClass",
"DefaultTolerationSeconds",
"LimitRanger",
"MutatingAdmissionWebhook",
"NamespaceLifecycle",
"PersistentVolumeClaimResize",
"PodSecurity",
"Priority",
"ResourceQuota",
"RuntimeClass",
"ServiceAccount",
"StorageObjectInUseProtection",
"TaintNodesByCondition",
"ValidatingAdmissionPolicy",
"ValidatingAdmissionWebhook"
]
},
"cidr_pods": "string",
"cidr_service": "string",
"cluster_dns": "string",
"tags": {
"key": "value"
},
"auto_maintenances": {
"minor_upgrade_maintenance": {
"enabled": true,
"duration_hours": 0,
"start_hour": 12,
"week_day": "Mon",
"tz": "UTC"
},
"patch_upgrade_maintenance": {
"enabled": true,
"duration_hours": 0,
"start_hour": 12,
"week_day": "Mon",
"tz": "UTC"
}
},
"maintenance_window": {
"duration_hours": 23,
"start_hour": 23,
"week_day": "Mon",
"tz": "UTC"
},
"control_planes": "string",
"expected_control_planes": "string",
"admin_whitelist": [
"string"
],
"statuses": {
"created_at": "2019-08-24T14:15:22Z",
"deleted_at": "2019-08-24T14:15:22Z",
"updated_at": "2019-08-24T14:15:22Z",
"status": "string",
"available_upgrade": ""
},
"disable_api_termination": false,
"auth": {
"oidc": {
"issuer-url": "string",
"client-id": "string",
"username-claim": "string",
"username-prefix": "string",
"groups-claim": [
"string"
],
"groups-prefix": "string",
"required-claim": {
"claim": "value"
}
}
}
}
]
}
200 response (ClusterResponseList object):
| Response Element | Type | Description |
|---|---|---|
| ResponseContext | clusters__cluster_schema__ResponseContext object | Information about the context of the response. |
| RequestId | string | The ID of the API request. |
| Pagination | Pagination object | Information used to split large lists of results into multiple responses (either cursor or offset-based). |
| cursor | Cursor object, or null |
Information used for cursor-based pagination. |
| next_cursor | string, or null |
The pagination token indicating where the next set of results should start. |
| offset | Offset object, or null |
Information used for offset-based pagination. |
| page | integer, or null |
The page number of the current results. |
| limit | integer, or null |
The maximum number of results returned per page. |
| total | integer, or null |
The total number of available results. |
| Clusters | [Cluster object] | Information about the clusters. |
| project_id | string | The ID of the project this cluster belongs to. |
| id | string | The Universally Unique Identifier (UUID) of the cluster. |
| name | string | A unique name for the cluster within the project. |
| description | string | An optional description of the cluster. Default: . |
| cp_multi_az | boolean | If true, multi-Subregion deployment is enabled for the control plane. If false, it is disabled. |
| cp_subregions | [string] | The Subregions on which the control plane components are deployed. |
| version | string | The Kubernetes version deployed for the cluster. For more information, see GetKubernetesVersions. |
| expected_version | string, or null |
The version of Kubernetes that is expected to be deployed during maintenance. |
| cni | string | The Container Network Interface (CNI) used in the cluster. |
| admin_lbu | boolean | If true, load balancer administration is enabled for cluster management. If false, it is disabled. |
| admission_flags | AdmissionFlags object | The configuration for Kubernetes admission controllers. |
| disable_admission_plugins | [string] | The list of Kubernetes admission plugins that are disabled. Default: []. |
| enable_admission_plugins | [string] | The list of Kubernetes admission plugins that are enabled. Default: []. |
| applied_admission_plugins | [string] | The list of admission plugins that are currently applied to the cluster. Default: ["CertificateApproval", "CertificateSigning", "CertificateSubjectRestriction", "ClusterTrustBundleAttest", "DefaultIngressClass", "DefaultStorageClass", "DefaultTolerationSeconds", "LimitRanger", "MutatingAdmissionWebhook", "NamespaceLifecycle", "PersistentVolumeClaimResize", "PodSecurity", "Priority", "ResourceQuota", "RuntimeClass", "ServiceAccount", "StorageObjectInUseProtection", "TaintNodesByCondition", "ValidatingAdmissionPolicy", "ValidatingAdmissionWebhook"]. |
| cidr_pods | string | The CIDR block of the Kubernetes pods' network. |
| cidr_service | string | The CIDR block of the Kubernetes services' network. |
| cluster_dns | string | The IP of the cluster's DNS service. |
| tags | object | The key/value combinations of the tags associated with the cluster, in the following format: "tags":{"TAGKEY1":"TAGVALUE1","TAGKEY2":"TAGVALUE2"}.Example: {"key": "value"}. |
| additional properties | string | |
| auto_maintenances Deprecated | AutoMaintenances object, or null |
The configuration for automated maintenance windows. |
| minor_upgrade_maintenance | MaintenanceWindow object | The maintenance window configuration for minor Kubernetes upgrades. |
| enabled | boolean | If true, a maintenance window is enabled. Default: true. |
| duration_hours | integer | The duration of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. Default: 0. |
| start_hour | integer | The starting time of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. Default: 12. |
| week_day | string | The weekday on which the maintenance window begins. Possible values: Mon | Tue | Wed | Thu | Fri | Sat | Sun | string. Default: Tue. |
| tz | string | The timezone for the maintenance window. Default: UTC. |
| patch_upgrade_maintenance | MaintenanceWindow object | The maintenance window configuration for patch Kubernetes upgrades. |
| enabled | boolean | If true, a maintenance window is enabled. Default: true. |
| duration_hours | integer | The duration of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. Default: 0. |
| start_hour | integer | The starting time of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. Default: 12. |
| week_day | string | The weekday on which the maintenance window begins. Possible values: Mon | Tue | Wed | Thu | Fri | Sat | Sun | string. Default: Tue. |
| tz | string | The timezone for the maintenance window. Default: UTC. |
| maintenance_window | Maintenance object, or null |
The configuration for automated maintenance windows. |
| duration_hours | integer | The duration of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. |
| start_hour | integer | The starting time of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. |
| week_day | string | The weekday on which the maintenance window begins. Possible values: Mon | Tue | Wed | Thu | Fri | Sat | Sun | string. |
| tz | string | The timezone for the maintenance window. Default: UTC. |
| control_planes | string | The control plane sizing of the cluster. |
| expected_control_planes | string, or null |
The type of control plane size that is expected. |
| admin_whitelist | [string] | The list of CIDR blocks or IPs allowed to access the cluster via the Kubernetes API. |
| statuses | Statuses object | The status information of the cluster. |
| created_at | string (date-time) | The timestamp when the cluster was created. |
| deleted_at | string (date-time), or null |
The timestamp when the cluster was deleted (if applicable). |
| updated_at | string (date-time), or null |
The timestamp when the cluster was last updated. |
| status | string, or null |
The status of the cluster. |
| available_upgrade | string | Any available version of Kubernetes for upgrade (if applicable). For more information, see GetKubernetesVersions. Default: . |
| disable_api_termination | boolean | If true, cluster deletion through the API is disabled. If false, it is enabled. Default: false. |
| auth | AuthStrategy object, or null |
The authentication strategy used to access the cluster. |
| oidc | OpenIdConnectConfig object, or null |
The configuration for authenticating to the cluster using OpenID Connect (OIDC). |
| issuer-url | string | The server URL of the OIDC provider, using the HTTPS protocol (https://). |
| client-id | string | The client ID provided by the OIDC provider. This will be used by the cluster to connect to the server. |
| username-claim | string, or null |
A JSON Web Token (JWT) claim provided by the OIDC provider. This will be used to retrieve the username on the Kubernetes side. |
| username-prefix | string, or null |
A prefix added to the Kubernetes username, to prevent clashing with existing names (for example, oidc:). |
| groups-claim | [string], or null |
A JSON Web Token (JWT) claim provided by the OIDC provider. This will be used to retrieve the user's group on the Kubernetes side. |
| groups-prefix | string, or null |
A prefix added to the Kubernetes group, to prevent clashing with existing names (for example, oidc:). |
| required-claim | object, or null |
The key/value combination of OIDC claims that must be included in the ID token for the user to authenticate. If not specified, no claim-based restrictions are enforced. Example: {"claim": "value"}. |
| additional properties | string, or boolean, or integer, or number |
Other responses:
- 400 response (ErrorResponse object): The HTTP 400 response (Bad Request).
- 404 response (ErrorResponse object): The HTTP 404 response (Not Found).
- 422 response (ErrorResponse object): The HTTP 422 response (Unprocessable Content).
- 500 response (ErrorResponse object): The HTTP 500 response (Internal Server Error).
GetCluster
GET /clusters/{cluster_id}
Gets information about a specific cluster.
Request Parameters
# Example with access key/secret key authentication
# (See the "Authentication Schemes" section for other authentications)
curl -X GET 'https://api.'$OSC_REGION'.oks.outscale.com/api/v2/clusters/{cluster_id}' \
--header 'AccessKey: '$OSC_ACCESS_KEY \
--header 'SecretKey: '$OSC_SECRET_KEY
# Example with access key/secret key authentication
# (See the "Authentication Schemes" section for other authentications)
GET /api/v2/clusters/{cluster_id} HTTP/1.1
Host: api.eu-west-2.oks.outscale.com
AccessKey: XXXX
SecretKey: YYYY
There is no equivalent for this method in the Terraform OUTSCALE provider.
Path:
| Path Parameter | Type | Description |
|---|---|---|
| cluster_id (required) | string | The name of the cluster. |
Response Elements
{
"ResponseContext": {
"RequestId": "string"
},
"Cluster": {
"project_id": "string",
"id": "string",
"name": "string",
"description": "",
"cp_multi_az": true,
"cp_subregions": [
"string"
],
"version": "string",
"expected_version": "string",
"cni": "string",
"admin_lbu": true,
"admission_flags": {
"disable_admission_plugins": [],
"enable_admission_plugins": [],
"applied_admission_plugins": [
"CertificateApproval",
"CertificateSigning",
"CertificateSubjectRestriction",
"ClusterTrustBundleAttest",
"DefaultIngressClass",
"DefaultStorageClass",
"DefaultTolerationSeconds",
"LimitRanger",
"MutatingAdmissionWebhook",
"NamespaceLifecycle",
"PersistentVolumeClaimResize",
"PodSecurity",
"Priority",
"ResourceQuota",
"RuntimeClass",
"ServiceAccount",
"StorageObjectInUseProtection",
"TaintNodesByCondition",
"ValidatingAdmissionPolicy",
"ValidatingAdmissionWebhook"
]
},
"cidr_pods": "string",
"cidr_service": "string",
"cluster_dns": "string",
"tags": {
"key": "value"
},
"auto_maintenances": {
"minor_upgrade_maintenance": {
"enabled": true,
"duration_hours": 0,
"start_hour": 12,
"week_day": "Mon",
"tz": "UTC"
},
"patch_upgrade_maintenance": {
"enabled": true,
"duration_hours": 0,
"start_hour": 12,
"week_day": "Mon",
"tz": "UTC"
}
},
"maintenance_window": {
"duration_hours": 23,
"start_hour": 23,
"week_day": "Mon",
"tz": "UTC"
},
"control_planes": "string",
"expected_control_planes": "string",
"admin_whitelist": [
"string"
],
"statuses": {
"created_at": "2019-08-24T14:15:22Z",
"deleted_at": "2019-08-24T14:15:22Z",
"updated_at": "2019-08-24T14:15:22Z",
"status": "string",
"available_upgrade": ""
},
"disable_api_termination": false,
"auth": {
"oidc": {
"issuer-url": "string",
"client-id": "string",
"username-claim": "string",
"username-prefix": "string",
"groups-claim": [
"string"
],
"groups-prefix": "string",
"required-claim": {
"claim": "value"
}
}
}
}
}
200 response (ClusterResponse object):
| Response Element | Type | Description |
|---|---|---|
| ResponseContext | clusters__cluster_schema__ResponseContext object | Information about the context of the response. |
| RequestId | string | The ID of the API request. |
| Cluster | Cluster object | Information about the cluster. |
| project_id | string | The ID of the project this cluster belongs to. |
| id | string | The Universally Unique Identifier (UUID) of the cluster. |
| name | string | A unique name for the cluster within the project. |
| description | string | An optional description of the cluster. Default: . |
| cp_multi_az | boolean | If true, multi-Subregion deployment is enabled for the control plane. If false, it is disabled. |
| cp_subregions | [string] | The Subregions on which the control plane components are deployed. |
| version | string | The Kubernetes version deployed for the cluster. For more information, see GetKubernetesVersions. |
| expected_version | string, or null |
The version of Kubernetes that is expected to be deployed during maintenance. |
| cni | string | The Container Network Interface (CNI) used in the cluster. |
| admin_lbu | boolean | If true, load balancer administration is enabled for cluster management. If false, it is disabled. |
| admission_flags | AdmissionFlags object | The configuration for Kubernetes admission controllers. |
| disable_admission_plugins | [string] | The list of Kubernetes admission plugins that are disabled. Default: []. |
| enable_admission_plugins | [string] | The list of Kubernetes admission plugins that are enabled. Default: []. |
| applied_admission_plugins | [string] | The list of admission plugins that are currently applied to the cluster. Default: ["CertificateApproval", "CertificateSigning", "CertificateSubjectRestriction", "ClusterTrustBundleAttest", "DefaultIngressClass", "DefaultStorageClass", "DefaultTolerationSeconds", "LimitRanger", "MutatingAdmissionWebhook", "NamespaceLifecycle", "PersistentVolumeClaimResize", "PodSecurity", "Priority", "ResourceQuota", "RuntimeClass", "ServiceAccount", "StorageObjectInUseProtection", "TaintNodesByCondition", "ValidatingAdmissionPolicy", "ValidatingAdmissionWebhook"]. |
| cidr_pods | string | The CIDR block of the Kubernetes pods' network. |
| cidr_service | string | The CIDR block of the Kubernetes services' network. |
| cluster_dns | string | The IP of the cluster's DNS service. |
| tags | object | The key/value combinations of the tags associated with the cluster, in the following format: "tags":{"TAGKEY1":"TAGVALUE1","TAGKEY2":"TAGVALUE2"}.Example: {"key": "value"}. |
| additional properties | string | |
| auto_maintenances Deprecated | AutoMaintenances object, or null |
The configuration for automated maintenance windows. |
| minor_upgrade_maintenance | MaintenanceWindow object | The maintenance window configuration for minor Kubernetes upgrades. |
| enabled | boolean | If true, a maintenance window is enabled. Default: true. |
| duration_hours | integer | The duration of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. Default: 0. |
| start_hour | integer | The starting time of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. Default: 12. |
| week_day | string | The weekday on which the maintenance window begins. Possible values: Mon | Tue | Wed | Thu | Fri | Sat | Sun | string. Default: Tue. |
| tz | string | The timezone for the maintenance window. Default: UTC. |
| patch_upgrade_maintenance | MaintenanceWindow object | The maintenance window configuration for patch Kubernetes upgrades. |
| enabled | boolean | If true, a maintenance window is enabled. Default: true. |
| duration_hours | integer | The duration of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. Default: 0. |
| start_hour | integer | The starting time of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. Default: 12. |
| week_day | string | The weekday on which the maintenance window begins. Possible values: Mon | Tue | Wed | Thu | Fri | Sat | Sun | string. Default: Tue. |
| tz | string | The timezone for the maintenance window. Default: UTC. |
| maintenance_window | Maintenance object, or null |
The configuration for automated maintenance windows. |
| duration_hours | integer | The duration of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. |
| start_hour | integer | The starting time of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. |
| week_day | string | The weekday on which the maintenance window begins. Possible values: Mon | Tue | Wed | Thu | Fri | Sat | Sun | string. |
| tz | string | The timezone for the maintenance window. Default: UTC. |
| control_planes | string | The control plane sizing of the cluster. |
| expected_control_planes | string, or null |
The type of control plane size that is expected. |
| admin_whitelist | [string] | The list of CIDR blocks or IPs allowed to access the cluster via the Kubernetes API. |
| statuses | Statuses object | The status information of the cluster. |
| created_at | string (date-time) | The timestamp when the cluster was created. |
| deleted_at | string (date-time), or null |
The timestamp when the cluster was deleted (if applicable). |
| updated_at | string (date-time), or null |
The timestamp when the cluster was last updated. |
| status | string, or null |
The status of the cluster. |
| available_upgrade | string | Any available version of Kubernetes for upgrade (if applicable). For more information, see GetKubernetesVersions. Default: . |
| disable_api_termination | boolean | If true, cluster deletion through the API is disabled. If false, it is enabled. Default: false. |
| auth | AuthStrategy object, or null |
The authentication strategy used to access the cluster. |
| oidc | OpenIdConnectConfig object, or null |
The configuration for authenticating to the cluster using OpenID Connect (OIDC). |
| issuer-url | string | The server URL of the OIDC provider, using the HTTPS protocol (https://). |
| client-id | string | The client ID provided by the OIDC provider. This will be used by the cluster to connect to the server. |
| username-claim | string, or null |
A JSON Web Token (JWT) claim provided by the OIDC provider. This will be used to retrieve the username on the Kubernetes side. |
| username-prefix | string, or null |
A prefix added to the Kubernetes username, to prevent clashing with existing names (for example, oidc:). |
| groups-claim | [string], or null |
A JSON Web Token (JWT) claim provided by the OIDC provider. This will be used to retrieve the user's group on the Kubernetes side. |
| groups-prefix | string, or null |
A prefix added to the Kubernetes group, to prevent clashing with existing names (for example, oidc:). |
| required-claim | object, or null |
The key/value combination of OIDC claims that must be included in the ID token for the user to authenticate. If not specified, no claim-based restrictions are enforced. Example: {"claim": "value"}. |
| additional properties | string, or boolean, or integer, or number |
Other responses:
- 400 response (ErrorResponse object): The HTTP 400 response (Bad Request).
- 404 response (ErrorResponse object): The HTTP 404 response (Not Found).
- 422 response (ErrorResponse object): The HTTP 422 response (Unprocessable Content).
- 500 response (ErrorResponse object): The HTTP 500 response (Internal Server Error).
UpdateCluster
PATCH /clusters/{cluster_id}
Updates the configuration of an existing cluster.
Request Parameters
# Example with access key/secret key authentication
# (See the "Authentication Schemes" section for other authentications)
curl -X PATCH 'https://api.'$OSC_REGION'.oks.outscale.com/api/v2/clusters/{cluster_id}' \
--header 'AccessKey: '$OSC_ACCESS_KEY \
--header 'SecretKey: '$OSC_SECRET_KEY \
--header 'Content-Type: application/json' \
--data '{
"description": "string",
"admission_flags": {
"disable_admission_plugins": ["string"],
"enable_admission_plugins": ["string"]
},
"tags": {
"property1": "string",
"property2": "string"
},
"auto_maintenances": {
"minor_upgrade_maintenance": {
"enabled": true,
"duration_hours": 0,
"start_hour": 12,
"week_day": "Mon",
"tz": "UTC"
},
"patch_upgrade_maintenance": {
"enabled": true,
"duration_hours": 0,
"start_hour": 12,
"week_day": "Mon",
"tz": "UTC"
}
},
"maintenance_window": {
"duration_hours": 23,
"start_hour": 23,
"week_day": "Mon",
"tz": "UTC"
},
"admin_whitelist": ["string"],
"quirks": ["string"],
"disable_api_termination": true,
"version": "string",
"control_planes": "string",
"auth": {
"oidc": {
"issuer-url": "string",
"client-id": "string",
"username-claim": "string",
"username-prefix": "string",
"groups-claim": ["string"],
"groups-prefix": "string",
"required-claim": {"claim": "value"}
}
}
}'
# Example with access key/secret key authentication
# (See the "Authentication Schemes" section for other authentications)
PATCH /api/v2/clusters/{cluster_id} HTTP/1.1
Host: api.eu-west-2.oks.outscale.com
Content-Type: application/json
AccessKey: XXXX
SecretKey: YYYY
{
"description": "string",
"admission_flags": {
"disable_admission_plugins": ["string"],
"enable_admission_plugins": ["string"]
},
"tags": {
"property1": "string",
"property2": "string"
},
"auto_maintenances": {
"minor_upgrade_maintenance": {
"enabled": true,
"duration_hours": 0,
"start_hour": 12,
"week_day": "Mon",
"tz": "UTC"
},
"patch_upgrade_maintenance": {
"enabled": true,
"duration_hours": 0,
"start_hour": 12,
"week_day": "Mon",
"tz": "UTC"
}
},
"maintenance_window": {
"duration_hours": 23,
"start_hour": 23,
"week_day": "Mon",
"tz": "UTC"
},
"admin_whitelist": ["string"],
"quirks": ["string"],
"disable_api_termination": true,
"version": "string",
"control_planes": "string",
"auth": {
"oidc": {
"issuer-url": "string",
"client-id": "string",
"username-claim": "string",
"username-prefix": "string",
"groups-claim": ["string"],
"groups-prefix": "string",
"required-claim": {"claim": "value"}
}
}
}
See the outscale_oks_cluster resource in the Terraform OUTSCALE provider.
Path:
| Path Parameter | Type | Description |
|---|---|---|
| cluster_id (required) | string | The ID of the cluster. |
Body (ClusterUpdate object):
| Body Parameter | Type | Description |
|---|---|---|
| description | string, or null |
The updated description of the cluster. |
| admission_flags | AdmissionFlagsInput object, or null |
The updated configuration for Kubernetes admission controllers. |
| disable_admission_plugins | [string] | The list of Kubernetes admission plugins to disable. |
| enable_admission_plugins | [string] | The list of Kubernetes admission plugins to enable. |
| tags | object, or null |
The updated key/value combinations of the tags associated with the cluster's metadata, in the following format: "tags":{"TAGKEY1":"TAGVALUE1","TAGKEY2":"TAGVALUE2"}. |
| additional properties | string | |
| auto_maintenances Deprecated | AutoMaintenances object, or null |
The updated configuration for automated maintenance windows. |
| minor_upgrade_maintenance (required) | MaintenanceWindow object | The maintenance window configuration for minor Kubernetes upgrades. |
| enabled | boolean | If true, a maintenance window is enabled. Default: true. |
| duration_hours | integer | The duration of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. Default: 0. |
| start_hour | integer | The starting time of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. Default: 12. |
| week_day | string | The weekday on which the maintenance window begins. Possible values: Mon | Tue | Wed | Thu | Fri | Sat | Sun | string. Default: Tue. |
| tz | string | The timezone for the maintenance window. Default: UTC. |
| patch_upgrade_maintenance (required) | MaintenanceWindow object | The maintenance window configuration for patch Kubernetes upgrades. |
| enabled | boolean | If true, a maintenance window is enabled. Default: true. |
| duration_hours | integer | The duration of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. Default: 0. |
| start_hour | integer | The starting time of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. Default: 12. |
| week_day | string | The weekday on which the maintenance window begins. Possible values: Mon | Tue | Wed | Thu | Fri | Sat | Sun | string. Default: Tue. |
| tz | string | The timezone for the maintenance window. Default: UTC. |
| maintenance_window | Maintenance object, or null |
The updated configuration for automated maintenance windows. |
| duration_hours (required) | integer | The duration of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. |
| start_hour (required) | integer | The starting time of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. |
| week_day (required) | string | The weekday on which the maintenance window begins. Possible values: Mon | Tue | Wed | Thu | Fri | Sat | Sun | string. |
| tz | string | The timezone for the maintenance window. Default: UTC. |
| admin_whitelist | [string], or null |
The updated list of CIDR blocks or IPs allowed to access the cluster via the Kubernetes API. |
| quirks | [string], or null |
The updated list of special configurations or behaviors for the cluster. |
| disable_api_termination | boolean, or null |
If true, cluster deletion through the API is disabled. If false, it is enabled. |
| version | string, or null |
The updated version of Kubernetes for the cluster. For more information, see GetKubernetesVersions. |
| control_planes | string | The size of the control plane deployment for the cluster. |
| auth | AuthStrategy object, or null |
The authentication strategy used to access the cluster. |
| oidc | OpenIdConnectConfig object, or null |
The configuration for authenticating to the cluster using OpenID Connect (OIDC). |
| issuer-url (required) | string | The server URL of the OIDC provider, using the HTTPS protocol (https://). |
| client-id (required) | string | The client ID provided by the OIDC provider. This will be used by the cluster to connect to the server. |
| username-claim | string, or null |
A JSON Web Token (JWT) claim provided by the OIDC provider. This will be used to retrieve the username on the Kubernetes side. |
| username-prefix | string, or null |
A prefix added to the Kubernetes username, to prevent clashing with existing names (for example, oidc:). |
| groups-claim | [string], or null |
A JSON Web Token (JWT) claim provided by the OIDC provider. This will be used to retrieve the user's group on the Kubernetes side. |
| groups-prefix | string, or null |
A prefix added to the Kubernetes group, to prevent clashing with existing names (for example, oidc:). |
| required-claim | object, or null |
The key/value combination of OIDC claims that must be included in the ID token for the user to authenticate. If not specified, no claim-based restrictions are enforced. Example: {"claim": "value"}. |
| additional properties | string, or boolean, or integer, or number |
Response Elements
{
"ResponseContext": {
"RequestId": "string"
},
"Cluster": {
"project_id": "string",
"id": "string",
"name": "string",
"description": "",
"cp_multi_az": true,
"cp_subregions": [
"string"
],
"version": "string",
"expected_version": "string",
"cni": "string",
"admin_lbu": true,
"admission_flags": {
"disable_admission_plugins": [],
"enable_admission_plugins": [],
"applied_admission_plugins": [
"CertificateApproval",
"CertificateSigning",
"CertificateSubjectRestriction",
"ClusterTrustBundleAttest",
"DefaultIngressClass",
"DefaultStorageClass",
"DefaultTolerationSeconds",
"LimitRanger",
"MutatingAdmissionWebhook",
"NamespaceLifecycle",
"PersistentVolumeClaimResize",
"PodSecurity",
"Priority",
"ResourceQuota",
"RuntimeClass",
"ServiceAccount",
"StorageObjectInUseProtection",
"TaintNodesByCondition",
"ValidatingAdmissionPolicy",
"ValidatingAdmissionWebhook"
]
},
"cidr_pods": "string",
"cidr_service": "string",
"cluster_dns": "string",
"tags": {
"key": "value"
},
"auto_maintenances": {
"minor_upgrade_maintenance": {
"enabled": true,
"duration_hours": 0,
"start_hour": 12,
"week_day": "Mon",
"tz": "UTC"
},
"patch_upgrade_maintenance": {
"enabled": true,
"duration_hours": 0,
"start_hour": 12,
"week_day": "Mon",
"tz": "UTC"
}
},
"maintenance_window": {
"duration_hours": 23,
"start_hour": 23,
"week_day": "Mon",
"tz": "UTC"
},
"control_planes": "string",
"expected_control_planes": "string",
"admin_whitelist": [
"string"
],
"statuses": {
"created_at": "2019-08-24T14:15:22Z",
"deleted_at": "2019-08-24T14:15:22Z",
"updated_at": "2019-08-24T14:15:22Z",
"status": "string",
"available_upgrade": ""
},
"disable_api_termination": false,
"auth": {
"oidc": {
"issuer-url": "string",
"client-id": "string",
"username-claim": "string",
"username-prefix": "string",
"groups-claim": [
"string"
],
"groups-prefix": "string",
"required-claim": {
"claim": "value"
}
}
}
}
}
200 response (ClusterResponse object):
| Response Element | Type | Description |
|---|---|---|
| ResponseContext | clusters__cluster_schema__ResponseContext object | Information about the context of the response. |
| RequestId | string | The ID of the API request. |
| Cluster | Cluster object | Information about the cluster. |
| project_id | string | The ID of the project this cluster belongs to. |
| id | string | The Universally Unique Identifier (UUID) of the cluster. |
| name | string | A unique name for the cluster within the project. |
| description | string | An optional description of the cluster. Default: . |
| cp_multi_az | boolean | If true, multi-Subregion deployment is enabled for the control plane. If false, it is disabled. |
| cp_subregions | [string] | The Subregions on which the control plane components are deployed. |
| version | string | The Kubernetes version deployed for the cluster. For more information, see GetKubernetesVersions. |
| expected_version | string, or null |
The version of Kubernetes that is expected to be deployed during maintenance. |
| cni | string | The Container Network Interface (CNI) used in the cluster. |
| admin_lbu | boolean | If true, load balancer administration is enabled for cluster management. If false, it is disabled. |
| admission_flags | AdmissionFlags object | The configuration for Kubernetes admission controllers. |
| disable_admission_plugins | [string] | The list of Kubernetes admission plugins that are disabled. Default: []. |
| enable_admission_plugins | [string] | The list of Kubernetes admission plugins that are enabled. Default: []. |
| applied_admission_plugins | [string] | The list of admission plugins that are currently applied to the cluster. Default: ["CertificateApproval", "CertificateSigning", "CertificateSubjectRestriction", "ClusterTrustBundleAttest", "DefaultIngressClass", "DefaultStorageClass", "DefaultTolerationSeconds", "LimitRanger", "MutatingAdmissionWebhook", "NamespaceLifecycle", "PersistentVolumeClaimResize", "PodSecurity", "Priority", "ResourceQuota", "RuntimeClass", "ServiceAccount", "StorageObjectInUseProtection", "TaintNodesByCondition", "ValidatingAdmissionPolicy", "ValidatingAdmissionWebhook"]. |
| cidr_pods | string | The CIDR block of the Kubernetes pods' network. |
| cidr_service | string | The CIDR block of the Kubernetes services' network. |
| cluster_dns | string | The IP of the cluster's DNS service. |
| tags | object | The key/value combinations of the tags associated with the cluster, in the following format: "tags":{"TAGKEY1":"TAGVALUE1","TAGKEY2":"TAGVALUE2"}.Example: {"key": "value"}. |
| additional properties | string | |
| auto_maintenances Deprecated | AutoMaintenances object, or null |
The configuration for automated maintenance windows. |
| minor_upgrade_maintenance | MaintenanceWindow object | The maintenance window configuration for minor Kubernetes upgrades. |
| enabled | boolean | If true, a maintenance window is enabled. Default: true. |
| duration_hours | integer | The duration of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. Default: 0. |
| start_hour | integer | The starting time of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. Default: 12. |
| week_day | string | The weekday on which the maintenance window begins. Possible values: Mon | Tue | Wed | Thu | Fri | Sat | Sun | string. Default: Tue. |
| tz | string | The timezone for the maintenance window. Default: UTC. |
| patch_upgrade_maintenance | MaintenanceWindow object | The maintenance window configuration for patch Kubernetes upgrades. |
| enabled | boolean | If true, a maintenance window is enabled. Default: true. |
| duration_hours | integer | The duration of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. Default: 0. |
| start_hour | integer | The starting time of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. Default: 12. |
| week_day | string | The weekday on which the maintenance window begins. Possible values: Mon | Tue | Wed | Thu | Fri | Sat | Sun | string. Default: Tue. |
| tz | string | The timezone for the maintenance window. Default: UTC. |
| maintenance_window | Maintenance object, or null |
The configuration for automated maintenance windows. |
| duration_hours | integer | The duration of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. |
| start_hour | integer | The starting time of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. |
| week_day | string | The weekday on which the maintenance window begins. Possible values: Mon | Tue | Wed | Thu | Fri | Sat | Sun | string. |
| tz | string | The timezone for the maintenance window. Default: UTC. |
| control_planes | string | The control plane sizing of the cluster. |
| expected_control_planes | string, or null |
The type of control plane size that is expected. |
| admin_whitelist | [string] | The list of CIDR blocks or IPs allowed to access the cluster via the Kubernetes API. |
| statuses | Statuses object | The status information of the cluster. |
| created_at | string (date-time) | The timestamp when the cluster was created. |
| deleted_at | string (date-time), or null |
The timestamp when the cluster was deleted (if applicable). |
| updated_at | string (date-time), or null |
The timestamp when the cluster was last updated. |
| status | string, or null |
The status of the cluster. |
| available_upgrade | string | Any available version of Kubernetes for upgrade (if applicable). For more information, see GetKubernetesVersions. Default: . |
| disable_api_termination | boolean | If true, cluster deletion through the API is disabled. If false, it is enabled. Default: false. |
| auth | AuthStrategy object, or null |
The authentication strategy used to access the cluster. |
| oidc | OpenIdConnectConfig object, or null |
The configuration for authenticating to the cluster using OpenID Connect (OIDC). |
| issuer-url | string | The server URL of the OIDC provider, using the HTTPS protocol (https://). |
| client-id | string | The client ID provided by the OIDC provider. This will be used by the cluster to connect to the server. |
| username-claim | string, or null |
A JSON Web Token (JWT) claim provided by the OIDC provider. This will be used to retrieve the username on the Kubernetes side. |
| username-prefix | string, or null |
A prefix added to the Kubernetes username, to prevent clashing with existing names (for example, oidc:). |
| groups-claim | [string], or null |
A JSON Web Token (JWT) claim provided by the OIDC provider. This will be used to retrieve the user's group on the Kubernetes side. |
| groups-prefix | string, or null |
A prefix added to the Kubernetes group, to prevent clashing with existing names (for example, oidc:). |
| required-claim | object, or null |
The key/value combination of OIDC claims that must be included in the ID token for the user to authenticate. If not specified, no claim-based restrictions are enforced. Example: {"claim": "value"}. |
| additional properties | string, or boolean, or integer, or number |
Other responses:
- 400 response (ErrorResponse object): The HTTP 400 response (Bad Request).
- 404 response (ErrorResponse object): The HTTP 404 response (Not Found).
- 409 response (ErrorResponse object): The HTTP 409 response (Conflict).
- 422 response (ErrorResponse object): The HTTP 422 response (Unprocessable Content).
- 423 response (ErrorResponse object): The HTTP 423 response (Locked Resource).
- 500 response (ErrorResponse object): The HTTP 500 response (Internal Server Error).
- 503 response (ErrorResponse object): The HTTP 503 response (Service Unavailable).
DeleteCluster
DELETE /clusters/{cluster_id}
Deletes a specific cluster.
Request Parameters
# Example with access key/secret key authentication
# (See the "Authentication Schemes" section for other authentications)
curl -X DELETE 'https://api.'$OSC_REGION'.oks.outscale.com/api/v2/clusters/{cluster_id}' \
--header 'AccessKey: '$OSC_ACCESS_KEY \
--header 'SecretKey: '$OSC_SECRET_KEY
# Example with access key/secret key authentication
# (See the "Authentication Schemes" section for other authentications)
DELETE /api/v2/clusters/{cluster_id} HTTP/1.1
Host: api.eu-west-2.oks.outscale.com
AccessKey: XXXX
SecretKey: YYYY
See the outscale_oks_cluster resource in the Terraform OUTSCALE provider.
Path:
| Path Parameter | Type | Description |
|---|---|---|
| cluster_id (required) | string | The ID of the cluster. |
Response Elements
{
"ResponseContext": {
"RequestId": "string"
},
"detail": "string"
}
200 response (DetailResponse object):
| Response Element | Type | Description |
|---|---|---|
| ResponseContext | projects__project_schema__ResponseContext object | Information about the context of the response. |
| RequestId | string | The ID of the API request. |
| detail | string | A detailed message related to the API response. |
Other responses:
- 403 response (ErrorResponse object): The HTTP 403 response (Forbidden).
- 404 response (ErrorResponse object): The HTTP 404 response (Not Found).
- 409 response (ErrorResponse object): The HTTP 409 response (Conflict).
- 422 response (ErrorResponse object): The HTTP 422 response (Unprocessable Content).
- 423 response (ErrorResponse object): The HTTP 423 response (Locked Resource).
- 500 response (ErrorResponse object): The HTTP 500 response (Internal Server Error).
- 503 response (ErrorResponse object): The HTTP 503 response (Service Unavailable).
GetKubeconfig
GET /clusters/{cluster_id}/kubeconfig
Gets the kubeconfig file for a specific cluster. You can specify query parameters for the kubeconfig file.
Request Parameters
# Example with access key/secret key authentication
# (See the "Authentication Schemes" section for other authentications)
curl -X GET 'https://api.'$OSC_REGION'.oks.outscale.com/api/v2/clusters/{cluster_id}/kubeconfig?user=string&group=string&ttl=string' \
--header 'AccessKey: '$OSC_ACCESS_KEY \
--header 'SecretKey: '$OSC_SECRET_KEY
# Example with access key/secret key authentication
# (See the "Authentication Schemes" section for other authentications)
GET /api/v2/clusters/{cluster_id}/kubeconfig?user=string&group=string&ttl=string HTTP/1.1
Host: api.eu-west-2.oks.outscale.com
AccessKey: XXXX
SecretKey: YYYY
See the outscale_oks_kubeconfig data source in the Terraform OUTSCALE provider.
Path:
| Path Parameter | Type | Description |
|---|---|---|
| cluster_id (required) | string | The ID of the cluster. |
Query:
| Query Parameter | Type | Description |
|---|---|---|
| user | string, or null |
The user of the kubeconfig file. |
| group | string, or null |
The group of the kubeconfig file. |
| ttl | string, or null |
The time to live (TTL) of the kubeconfig file. |
Response Elements
{
"ResponseContext": {
"RequestId": "string"
},
"Cluster": {
"request_id": "string",
"data": {
"kubeconfig": "string"
}
}
}
200 response (KubeconfigResponse object):
| Response Element | Type | Description |
|---|---|---|
| ResponseContext | clusters__cluster_schema__ResponseContext object | Information about the context of the response. |
| RequestId | string | The ID of the API request. |
| Cluster | clusters__cluster_schema__RPCResponse object | The kubeconfig details associated with the cluster. |
| request_id | string | The ID of the API request. |
| data | KubeconfigData object | The kubeconfig data for the cluster. |
| kubeconfig | string | The content of the kubeconfig file used to configure access to the cluster. |
Other responses:
- 400 response (ErrorResponse object): The HTTP 400 response (Bad Request).
- 404 response (ErrorResponse object): The HTTP 404 response (Not Found).
- 408 response (ErrorResponse object): The HTTP 408 response (Timeout)
- 409 response (ErrorResponse object): The HTTP 409 response (Conflict).
- 422 response (ErrorResponse object): The HTTP 422 response (Unprocessable Content).
- 500 response (ErrorResponse object): The HTTP 500 response (Internal Server Error).
- 503 response (ErrorResponse object): The HTTP 503 response (Service Unavailable).
GetKubeconfigWithPubkeyNACL
POST /clusters/{cluster_id}/kubeconfig
Gets the kubeconfig file for a specific cluster, optionally encrypted with a NaCl public key. For more information, see the NaCl website. You can specify query parameters for the kubeconfig file.
Request Parameters
# Example with access key/secret key authentication
# (See the "Authentication Schemes" section for other authentications)
curl -X POST 'https://api.'$OSC_REGION'.oks.outscale.com/api/v2/clusters/{cluster_id}/kubeconfig?user=string&group=string&ttl=string' \
--header 'AccessKey: '$OSC_ACCESS_KEY \
--header 'SecretKey: '$OSC_SECRET_KEY \
--header 'x-encrypt-nacl: string'
# Example with access key/secret key authentication
# (See the "Authentication Schemes" section for other authentications)
POST /api/v2/clusters/{cluster_id}/kubeconfig?user=string&group=string&ttl=string HTTP/1.1
Host: api.eu-west-2.oks.outscale.com
x-encrypt-nacl: string
AccessKey: XXXX
SecretKey: YYYY
See the outscale_oks_kubeconfig data source in the Terraform OUTSCALE provider.
Path:
| Path Parameter | Type | Description |
|---|---|---|
| cluster_id (required) | string | The ID of the cluster. |
Query:
| Query Parameter | Type | Description |
|---|---|---|
| user | string, or null |
The user of the kubeconfig file. |
| group | string, or null |
The group of the kubeconfig file. |
| ttl | string, or null |
The time to live (TTL) of the kubeconfig file. |
Headers:
| Header Parameter | Type | Description |
|---|---|---|
| x-encrypt-nacl | string, or null |
The header to encrypt the kubeconfig file. |
Response Elements
{
"ResponseContext": {
"RequestId": "string"
},
"Cluster": {
"request_id": "string",
"data": {
"kubeconfig": "string"
}
}
}
200 response (KubeconfigResponse object):
| Response Element | Type | Description |
|---|---|---|
| ResponseContext | clusters__cluster_schema__ResponseContext object | Information about the context of the response. |
| RequestId | string | The ID of the API request. |
| Cluster | clusters__cluster_schema__RPCResponse object | The kubeconfig details associated with the cluster. |
| request_id | string | The ID of the API request. |
| data | KubeconfigData object | The kubeconfig data for the cluster. |
| kubeconfig | string | The content of the kubeconfig file used to configure access to the cluster. |
Other responses:
- 400 response (ErrorResponse object): The HTTP 400 response (Bad Request).
- 404 response (ErrorResponse object): The HTTP 404 response (Not Found).
- 408 response (ErrorResponse object): The HTTP 408 response (Timeout)
- 409 response (ErrorResponse object): The HTTP 409 response (Conflict).
- 422 response (ErrorResponse object): The HTTP 422 response (Unprocessable Content).
- 500 response (ErrorResponse object): The HTTP 500 response (Internal Server Error).
- 503 response (ErrorResponse object): The HTTP 503 response (Service Unavailable).
UpgradeCluster
PATCH /clusters/{cluster_id}/upgrade
Upgrades a specific cluster to the latest available version of Kubernetes. For more information, see GetKubernetesVersions.
Request Parameters
# Example with access key/secret key authentication
# (See the "Authentication Schemes" section for other authentications)
curl -X PATCH 'https://api.'$OSC_REGION'.oks.outscale.com/api/v2/clusters/{cluster_id}/upgrade' \
--header 'AccessKey: '$OSC_ACCESS_KEY \
--header 'SecretKey: '$OSC_SECRET_KEY
# Example with access key/secret key authentication
# (See the "Authentication Schemes" section for other authentications)
PATCH /api/v2/clusters/{cluster_id}/upgrade HTTP/1.1
Host: api.eu-west-2.oks.outscale.com
AccessKey: XXXX
SecretKey: YYYY
See the outscale_oks_cluster resource in the Terraform OUTSCALE provider.
Path:
| Path Parameter | Type | Description |
|---|---|---|
| cluster_id (required) | string | The ID of the cluster. |
Response Elements
{
"ResponseContext": {
"RequestId": "string"
},
"Cluster": {
"project_id": "string",
"id": "string",
"name": "string",
"description": "",
"cp_multi_az": true,
"cp_subregions": [
"string"
],
"version": "string",
"expected_version": "string",
"cni": "string",
"admin_lbu": true,
"admission_flags": {
"disable_admission_plugins": [],
"enable_admission_plugins": [],
"applied_admission_plugins": [
"CertificateApproval",
"CertificateSigning",
"CertificateSubjectRestriction",
"ClusterTrustBundleAttest",
"DefaultIngressClass",
"DefaultStorageClass",
"DefaultTolerationSeconds",
"LimitRanger",
"MutatingAdmissionWebhook",
"NamespaceLifecycle",
"PersistentVolumeClaimResize",
"PodSecurity",
"Priority",
"ResourceQuota",
"RuntimeClass",
"ServiceAccount",
"StorageObjectInUseProtection",
"TaintNodesByCondition",
"ValidatingAdmissionPolicy",
"ValidatingAdmissionWebhook"
]
},
"cidr_pods": "string",
"cidr_service": "string",
"cluster_dns": "string",
"tags": {
"key": "value"
},
"auto_maintenances": {
"minor_upgrade_maintenance": {
"enabled": true,
"duration_hours": 0,
"start_hour": 12,
"week_day": "Mon",
"tz": "UTC"
},
"patch_upgrade_maintenance": {
"enabled": true,
"duration_hours": 0,
"start_hour": 12,
"week_day": "Mon",
"tz": "UTC"
}
},
"maintenance_window": {
"duration_hours": 23,
"start_hour": 23,
"week_day": "Mon",
"tz": "UTC"
},
"control_planes": "string",
"expected_control_planes": "string",
"admin_whitelist": [
"string"
],
"statuses": {
"created_at": "2019-08-24T14:15:22Z",
"deleted_at": "2019-08-24T14:15:22Z",
"updated_at": "2019-08-24T14:15:22Z",
"status": "string",
"available_upgrade": ""
},
"disable_api_termination": false,
"auth": {
"oidc": {
"issuer-url": "string",
"client-id": "string",
"username-claim": "string",
"username-prefix": "string",
"groups-claim": [
"string"
],
"groups-prefix": "string",
"required-claim": {
"claim": "value"
}
}
}
}
}
200 response (ClusterResponse object):
| Response Element | Type | Description |
|---|---|---|
| ResponseContext | clusters__cluster_schema__ResponseContext object | Information about the context of the response. |
| RequestId | string | The ID of the API request. |
| Cluster | Cluster object | Information about the cluster. |
| project_id | string | The ID of the project this cluster belongs to. |
| id | string | The Universally Unique Identifier (UUID) of the cluster. |
| name | string | A unique name for the cluster within the project. |
| description | string | An optional description of the cluster. Default: . |
| cp_multi_az | boolean | If true, multi-Subregion deployment is enabled for the control plane. If false, it is disabled. |
| cp_subregions | [string] | The Subregions on which the control plane components are deployed. |
| version | string | The Kubernetes version deployed for the cluster. For more information, see GetKubernetesVersions. |
| expected_version | string, or null |
The version of Kubernetes that is expected to be deployed during maintenance. |
| cni | string | The Container Network Interface (CNI) used in the cluster. |
| admin_lbu | boolean | If true, load balancer administration is enabled for cluster management. If false, it is disabled. |
| admission_flags | AdmissionFlags object | The configuration for Kubernetes admission controllers. |
| disable_admission_plugins | [string] | The list of Kubernetes admission plugins that are disabled. Default: []. |
| enable_admission_plugins | [string] | The list of Kubernetes admission plugins that are enabled. Default: []. |
| applied_admission_plugins | [string] | The list of admission plugins that are currently applied to the cluster. Default: ["CertificateApproval", "CertificateSigning", "CertificateSubjectRestriction", "ClusterTrustBundleAttest", "DefaultIngressClass", "DefaultStorageClass", "DefaultTolerationSeconds", "LimitRanger", "MutatingAdmissionWebhook", "NamespaceLifecycle", "PersistentVolumeClaimResize", "PodSecurity", "Priority", "ResourceQuota", "RuntimeClass", "ServiceAccount", "StorageObjectInUseProtection", "TaintNodesByCondition", "ValidatingAdmissionPolicy", "ValidatingAdmissionWebhook"]. |
| cidr_pods | string | The CIDR block of the Kubernetes pods' network. |
| cidr_service | string | The CIDR block of the Kubernetes services' network. |
| cluster_dns | string | The IP of the cluster's DNS service. |
| tags | object | The key/value combinations of the tags associated with the cluster, in the following format: "tags":{"TAGKEY1":"TAGVALUE1","TAGKEY2":"TAGVALUE2"}.Example: {"key": "value"}. |
| additional properties | string | |
| auto_maintenances Deprecated | AutoMaintenances object, or null |
The configuration for automated maintenance windows. |
| minor_upgrade_maintenance | MaintenanceWindow object | The maintenance window configuration for minor Kubernetes upgrades. |
| enabled | boolean | If true, a maintenance window is enabled. Default: true. |
| duration_hours | integer | The duration of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. Default: 0. |
| start_hour | integer | The starting time of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. Default: 12. |
| week_day | string | The weekday on which the maintenance window begins. Possible values: Mon | Tue | Wed | Thu | Fri | Sat | Sun | string. Default: Tue. |
| tz | string | The timezone for the maintenance window. Default: UTC. |
| patch_upgrade_maintenance | MaintenanceWindow object | The maintenance window configuration for patch Kubernetes upgrades. |
| enabled | boolean | If true, a maintenance window is enabled. Default: true. |
| duration_hours | integer | The duration of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. Default: 0. |
| start_hour | integer | The starting time of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. Default: 12. |
| week_day | string | The weekday on which the maintenance window begins. Possible values: Mon | Tue | Wed | Thu | Fri | Sat | Sun | string. Default: Tue. |
| tz | string | The timezone for the maintenance window. Default: UTC. |
| maintenance_window | Maintenance object, or null |
The configuration for automated maintenance windows. |
| duration_hours | integer | The duration of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. |
| start_hour | integer | The starting time of the maintenance window, in hours. Minimum value: 0. Maximum value: 23. |
| week_day | string | The weekday on which the maintenance window begins. Possible values: Mon | Tue | Wed | Thu | Fri | Sat | Sun | string. |
| tz | string | The timezone for the maintenance window. Default: UTC. |
| control_planes | string | The control plane sizing of the cluster. |
| expected_control_planes | string, or null |
The type of control plane size that is expected. |
| admin_whitelist | [string] | The list of CIDR blocks or IPs allowed to access the cluster via the Kubernetes API. |
| statuses | Statuses object | The status information of the cluster. |
| created_at | string (date-time) | The timestamp when the cluster was created. |
| deleted_at | string (date-time), or null |
The timestamp when the cluster was deleted (if applicable). |
| updated_at | string (date-time), or null |
The timestamp when the cluster was last updated. |
| status | string, or null |
The status of the cluster. |
| available_upgrade | string | Any available version of Kubernetes for upgrade (if applicable). For more information, see GetKubernetesVersions. Default: . |
| disable_api_termination | boolean | If true, cluster deletion through the API is disabled. If false, it is enabled. Default: false. |
| auth | AuthStrategy object, or null |
The authentication strategy used to access the cluster. |
| oidc | OpenIdConnectConfig object, or null |
The configuration for authenticating to the cluster using OpenID Connect (OIDC). |
| issuer-url | string | The server URL of the OIDC provider, using the HTTPS protocol (https://). |
| client-id | string | The client ID provided by the OIDC provider. This will be used by the cluster to connect to the server. |
| username-claim | string, or null |
A JSON Web Token (JWT) claim provided by the OIDC provider. This will be used to retrieve the username on the Kubernetes side. |
| username-prefix | string, or null |
A prefix added to the Kubernetes username, to prevent clashing with existing names (for example, oidc:). |
| groups-claim | [string], or null |
A JSON Web Token (JWT) claim provided by the OIDC provider. This will be used to retrieve the user's group on the Kubernetes side. |
| groups-prefix | string, or null |
A prefix added to the Kubernetes group, to prevent clashing with existing names (for example, oidc:). |
| required-claim | object, or null |
The key/value combination of OIDC claims that must be included in the ID token for the user to authenticate. If not specified, no claim-based restrictions are enforced. Example: {"claim": "value"}. |
| additional properties | string, or boolean, or integer, or number |
Other responses:
- 404 response (ErrorResponse object): The HTTP 404 response (Not Found).
- 409 response (ErrorResponse object): The HTTP 409 response (Conflict).
- 422 response (ErrorResponse object): The HTTP 422 response (Unprocessable Content).
- 423 response (ErrorResponse object): The HTTP 423 response (Locked Resource).
- 500 response (ErrorResponse object): The HTTP 500 response (Internal Server Error).
- 503 response (ErrorResponse object): The HTTP 503 response (Service Unavailable).
GetKubernetesVersions
GET /clusters/limits/kubernetes_versions
Gets the available Kubernetes versions for cluster creation or upgrades.
Request Parameters
# Example with access key/secret key authentication
# (See the "Authentication Schemes" section for other authentications)
curl -X GET 'https://api.'$OSC_REGION'.oks.outscale.com/api/v2/clusters/limits/kubernetes_versions' \
--header 'AccessKey: '$OSC_ACCESS_KEY \
--header 'SecretKey: '$OSC_SECRET_KEY
# Example with access key/secret key authentication
# (See the "Authentication Schemes" section for other authentications)
GET /api/v2/clusters/limits/kubernetes_versions HTTP/1.1
Host: api.eu-west-2.oks.outscale.com
AccessKey: XXXX
SecretKey: YYYY
There is no equivalent for this method in the Terraform OUTSCALE provider.
Response Elements
{
"ResponseContext": {
"RequestId": "string"
},
"Versions": [
"string"
]
}
200 response (KubernetesVersionsResponse object):
| Response Element | Type | Description |
|---|---|---|
| ResponseContext | clusters__cluster_schema__ResponseContext object | Information about the context of the response. |
| RequestId | string | The ID of the API request. |
| Versions | [string] | A list of available Kubernetes versions. |
Other responses:
- 422 response (ErrorResponse object): The HTTP 422 response (Unprocessable Content).
GetCPSubregions
GET /clusters/limits/cp_subregions
Gets the Subregions where you can deploy control planes for your clusters.
Request Parameters
# Example with access key/secret key authentication
# (See the "Authentication Schemes" section for other authentications)
curl -X GET 'https://api.'$OSC_REGION'.oks.outscale.com/api/v2/clusters/limits/cp_subregions' \
--header 'AccessKey: '$OSC_ACCESS_KEY \
--header 'SecretKey: '$OSC_SECRET_KEY
# Example with access key/secret key authentication
# (See the "Authentication Schemes" section for other authentications)
GET /api/v2/clusters/limits/cp_subregions HTTP/1.1
Host: api.eu-west-2.oks.outscale.com
AccessKey: XXXX
SecretKey: YYYY
There is no equivalent for this method in the Terraform OUTSCALE provider.
Response Elements
{
"ResponseContext": {
"RequestId": "string"
},
"CPSubregions": [
"string"
]
}
200 response (CPSubregionsResponse object):
| Response Element | Type | Description |
|---|---|---|
| ResponseContext | clusters__cluster_schema__ResponseContext object | Information about the context of the response. |
| RequestId | string | The ID of the API request. |
| CPSubregions | [string] | The list of Subregions where you can deploy control planes for your clusters. |
Other responses:
- 422 response (ErrorResponse object): The HTTP 422 response (Unprocessable Content).
GetControlPlanePlans
GET /clusters/limits/control_plane_plans
Gets the control plane types that you can use to create your clusters.
Request Parameters
# Example with access key/secret key authentication
# (See the "Authentication Schemes" section for other authentications)
curl -X GET 'https://api.'$OSC_REGION'.oks.outscale.com/api/v2/clusters/limits/control_plane_plans' \
--header 'AccessKey: '$OSC_ACCESS_KEY \
--header 'SecretKey: '$OSC_SECRET_KEY
# Example with access key/secret key authentication
# (See the "Authentication Schemes" section for other authentications)
GET /api/v2/clusters/limits/control_plane_plans HTTP/1.1
Host: api.eu-west-2.oks.outscale.com
AccessKey: XXXX
SecretKey: YYYY
There is no equivalent for this method in the Terraform OUTSCALE provider.
Response Elements
{
"ResponseContext": {
"RequestId": "string"
},
"ControlPlanes": [
"string"
]
}
200 response (ControlPlanesResponse object):
| Response Element | Type | Description |
|---|---|---|
| ResponseContext | clusters__cluster_schema__ResponseContext object | Information about the context of the response. |
| RequestId | string | The ID of the API request. |
| ControlPlanes | [string] | The list of available control plane types. |
Other responses:
- 422 response (ErrorResponse object): The HTTP 422 response (Unprocessable Content).
MyIp
GetClientIP
GET /myip
Gets the IP of the client making the request.
Request Parameters
# Example with access key/secret key authentication
# (See the "Authentication Schemes" section for other authentications)
curl -X GET 'https://api.'$OSC_REGION'.oks.outscale.com/api/v2/myip' \
--header 'AccessKey: '$OSC_ACCESS_KEY \
--header 'SecretKey: '$OSC_SECRET_KEY \
--header 'X-Real-IP: string'
# Example with access key/secret key authentication
# (See the "Authentication Schemes" section for other authentications)
GET /api/v2/myip HTTP/1.1
Host: api.eu-west-2.oks.outscale.com
X-Real-IP: string
AccessKey: XXXX
SecretKey: YYYY
There is no equivalent for this method in the Terraform OUTSCALE provider.
Headers:
| Header Parameter | Type | Description |
|---|---|---|
| X-Real-IP | string, or null |
The IP of the client. |
Response Elements
{
"ResponseContext": {
"RequestId": "string"
},
"IP": {
"x_real_ip": "string"
}
}
200 response (IPResponse object):
| Response Element | Type | Description |
|---|---|---|
| ResponseContext | myip__myip_schema__ResponseContext object | Information about the context of the response. |
| RequestId | string | The ID of the API request. |
| IP | IPDetails object | Details related to the IP. |
| x_real_ip | string, or null |
The IP associated with the incoming request. |
Other responses:
- 422 response (ErrorResponse object): The HTTP 422 response (Unprocessable Content).
Projects
CreateProject
POST /projects
Creates a new project.
Request Parameters
# Example with access key/secret key authentication
# (See the "Authentication Schemes" section for other authentications)
curl -X POST 'https://api.'$OSC_REGION'.oks.outscale.com/api/v2/projects' \
--header 'AccessKey: '$OSC_ACCESS_KEY \
--header 'SecretKey: '$OSC_SECRET_KEY \
--header 'Content-Type: application/json' \
--data '{
"name": "awesome-project",
"description": "",
"cidr": "string",
"region": "string",
"tags": {
"key": "value"
},
"quirks": ["string"],
"disable_api_termination": false
}'
# Example with access key/secret key authentication
# (See the "Authentication Schemes" section for other authentications)
POST /api/v2/projects HTTP/1.1
Host: api.eu-west-2.oks.outscale.com
Content-Type: application/json
AccessKey: XXXX
SecretKey: YYYY
{
"name": "awesome-project",
"description": "",
"cidr": "string",
"region": "string",
"tags": {
"key": "value"
},
"quirks": ["string"],
"disable_api_termination": false
}
See the outscale_oks_project resource in the Terraform OUTSCALE provider.
Body (ProjectInput object):
| Body Parameter | Type | Description |
|---|---|---|
| name (required) | string | A unique name for the project. Must start with a letter and contain only lowercase letters, numbers, or hyphens. Length: 1 to 40 characters. Pattern: ^[a-z][a-z0-9-]*[a-z0-9]$.Example: awesome-project. |
| description | string | A description for the project. Default: . |
| cidr (required) | string | The CIDR block to associate with the Net of the project. |
| region (required) | string | The Region on which the project is deployed. |
| tags | object, or null |
The key/value combinations of the tags associated with the resource, in the following format: "tags":{"TAGKEY1":"TAGVALUE1","TAGKEY2":"TAGVALUE2"}.Example: {"key": "value"}. |
| additional properties | string | |
| quirks | [string], or null |
A list of special configurations or behaviors for the project. |
| disable_api_termination | boolean | If true, project deletion through the API is disabled. If false, it is enabled. Default: false. |
Response Elements
{
"ResponseContext": {
"RequestId": "string"
},
"Project": {
"id": "string",
"name": "string",
"description": "",
"cidr": "string",
"region": "string",
"status": "string",
"tags": {
"property1": "string",
"property2": "string"
},
"disable_api_termination": false,
"created_at": "2019-08-24T14:15:22Z",
"updated_at": "2019-08-24T14:15:22Z",
"deleted_at": "2019-08-24T14:15:22Z"
}
}
200 response (ProjectResponse object):
| Response Element | Type | Description |
|---|---|---|
| ResponseContext | projects__project_schema__ResponseContext object | Information about the context of the response. |
| RequestId | string | The ID of the API request. |
| Project | Project object | Information about the project. |
| id | string | The ID of the project. |
| name | string | The name of the project. |
| description | string | A description for the project. Default: . |
| cidr | string | The CIDR block associated with the Net of the project. |
| region | string | The Region on which the project is deployed. |
| status | string | The status of the project (pending | ready | updating | failed | deleting). |
| tags | object | The key/value combinations of the tags associated with the resource, in the following format: "tags":{"TAGKEY1":"TAGVALUE1","TAGKEY2":"TAGVALUE2"}. |
| additional properties | string | |
| disable_api_termination | boolean | If true, project deletion through the API is disabled. If false, it is enabled. Default: false. |
| created_at | string (date-time) | The timestamp when the project was created. |
| updated_at | string (date-time) | The timestamp when the project was last updated. |
| deleted_at | string (date-time), or null |
The timestamp when the project was deleted (if applicable). |
Other responses:
- 403 response (ErrorResponse object): The HTTP 403 response (Forbidden).
- 409 response (ErrorResponse object): The HTTP 409 response (Conflict).
- 422 response (ErrorResponse object): The HTTP 422 response (Unprocessable Content).
- 423 response (ErrorResponse object): The HTTP 423 response (Locked Resource).
- 500 response (ErrorResponse object): The HTTP 500 response (Internal Server Error).
- 503 response (ErrorResponse object): The HTTP 503 response (Service Unavailable).
ListProjects
GET /projects
Lists one or more of your projects. The response can be filtered using the parameters.
Request Parameters
# Example with access key/secret key authentication
# (See the "Authentication Schemes" section for other authentications)
curl -X GET 'https://api.'$OSC_REGION'.oks.outscale.com/api/v2/projects?name=string&status=string&cidr=string&deleted=true&cursor=string&page=0&limit=1' \
--header 'AccessKey: '$OSC_ACCESS_KEY \
--header 'SecretKey: '$OSC_SECRET_KEY
# Example with access key/secret key authentication
# (See the "Authentication Schemes" section for other authentications)
GET /api/v2/projects?name=string&status=string&cidr=string&deleted=true&cursor=string&page=0&limit=1 HTTP/1.1
Host: api.eu-west-2.oks.outscale.com
AccessKey: XXXX
SecretKey: YYYY
There is no equivalent for this method in the Terraform OUTSCALE provider.
Query:
| Query Parameter | Type | Description |
|---|---|---|
| name | string, or null |
The name of the projects. |
| status | string, or null |
The status of the projects (pending | ready | updating | failed | deleting). |
| cidr | string, or null |
The IP ranges for the projects, IN CIDR notation (for example, 192.0.2.0/16). |
| deleted | boolean, or null |
If true, returns deleted projects. |
| cursor | string, or null |
The token to indicate where the next set of results should start. |
| page | integer, or null |
The page number of results to retrieve. |
| limit | integer, or null |
The maximum number of results to return in the response. |
Response Elements
{
"ResponseContext": {
"RequestId": "string"
},
"Pagination": {
"cursor": {
"next_cursor": "string"
},
"offset": {
"page": 0,
"limit": 0,
"total": 0
}
},
[...]
